/*
--------------------------------------------------------------------
 This file is part of PaToH (Partitioning Tools for Hypergraphs)
 Copyright (c) 1996-   Umit V. Catalyurek
---------------------------------------------------------------------
 For license info, please see the README file in the main directory.
---------------------------------------------------------------------

  ------------------------------------------------------------------
   File   : uqsort.h         Modifed from Numerical Recipes Software
   Author : Umit V. Catalyurek
   Date   : Jul 29, 99
   ------------------------------------------------------------------
   Desc   : QuickSort
   ------------------------------------------------------------------
*/

#ifndef _UQSORT_H_
#define _UQSORT_H_

#include "ulib.h"

#ifdef __cplusplus
extern "C" {
#endif

/*************************************************************************
* -------------------------- Sort ----------------------------------------
**************************************************************************/

typedef struct TagSortItem
{
int id;
int val;
} SortItem;

typedef SortItem *PSortItem;

typedef struct TagfSortItem
{
int	id;
float	val;
} fSortItem;

typedef fSortItem *PfSortItem;

void uqsort(int n, PSortItem arr);
void uqsort_dec(int n, PSortItem arr);

void ufqsort(int n, PfSortItem arr);
void ufqsort_dec(int n, PfSortItem arr);

void uqsorti(int n, int *arr);

#ifdef __cplusplus
}
#endif

#endif
 
