#ifndef DGRAPHTRAVERSAL_H
#define DGRAPHTRAVERSAL_H

#include "dgraph.h"
#include "utils.h"

void checkTopsort(dgraph *G, idxType *toporder);
void topSortOnParts(dgraph *G, idxType *part, idxType *toporder, idxType nbpart);
void randTopSortOnParts(dgraph *G, idxType *part, idxType *toporder, idxType nbpart);
void topsortwithTies(dgraph *G, idxType *toporder);
void topsortPriorities(dgraph *G, idxType *toporder, ecType *priorities);

void DFStopsort(dgraph *G, idxType *toporder);
void BFStopsort(dgraph *G, idxType *toporder);
void randDFStopsort(dgraph *G, idxType *toporder);
void randBFStopsort(dgraph *G, idxType *toporder);
void DFSsort(dgraph *G, idxType *toporder);
void BFSsort(dgraph *G, idxType *toporder);
void randDFSsort(dgraph *G, idxType *toporder);
void randBFSsort(dgraph *G, idxType *toporder);
void randTopsort(dgraph *G, idxType *toporder);
void mixtopsort(dgraph *G, idxType *toporder,int priority,int first);
void randTopsort(dgraph *G, idxType *toporder);
void natural_with_part(dgraph *G, idxType* toporder, idxType *part, idxType *toporderpart, idxType nbpart);

void DFStopsort_with_part(dgraph* G, idxType *part, int nbpart, idxType *toporder);
void randDFStopsort_with_part(dgraph* G, idxType *part, int nbpart, idxType *toporder);
void BFStopsort_with_part(dgraph* G, idxType *part, int nbpart, idxType *toporder);
void randBFStopsort_with_part(dgraph* G, idxType *part, int nbpart, idxType *toporder);



#endif
