#ifndef SCHEDULING_H
#define SCHEDULING_H

#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <limits.h>
#include "dgraph.h"
#include "option.h"



idxType calcLiveSizeMix(dgraph *G, idxType* traversal, MLGP_option opt);
idxType calcLiveSizeMixMulti(dgraph *G, int rep, idxType* traversal, MLGP_option opt);
idxType calcLiveSize(dgraph *g,idxType* toporder, MLGP_option opt);
idxType calcLiveSize_Lmin(dgraph *g,idxType* toporder);
idxType calcLiveSize_L(dgraph *g,idxType* toporder);
idxType calcLiveSize_Lmax(dgraph *g,idxType* toporder);
idxType calcLiveSizeMix_with_part(dgraph *G, idxType* part, int nbpart, idxType* toporder, MLGP_option opt);
idxType calcLiveSizeMix_with_part_Multi(dgraph *G, idxType* part, int nbpart, idxType* toporder, int rep, MLGP_option opt);
idxType calcLiveSizePart(dgraph *g, idxType* toporder, idxType* part, idxType part_idx);
idxType calcLiveSizePartMix(dgraph *G, idxType* part, idxType part_idx);
idxType calcLiveSizePartMixMulti(dgraph *G, idxType* part, idxType part_idx, int rep);

idxType calcLiveSizeNatural(dgraph *G, MLGP_option opt);
idxType calcLiveSizeNatural_with_part(dgraph *G, idxType *part, int nbpart, MLGP_option opt);

idxType liveSize(dgraph *G, MLGP_option opt);
idxType liveSize_with_part(dgraph *G, idxType* part, int nbpart, MLGP_option opt);


#endif
