#ifndef UTILS_H_
#define UTILS_H_

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <fcntl.h>
#include <time.h>
#include <math.h>

#include "dgraph.h"

#define mymax(a, b)	(((a) >= (b)) ? (a) : (b))
#define isPowOfTwo(x)  (((x)!=0) && !((x)&((x)-1)))


#define UNUSED(x) (void)(x)


/* our random generatos */

int usRandom(int s);
int uGetSeed(void);
int uRandom(int l);

void u_errexit(char * f_str,...);
double u_wseconds(void);

void* umalloc(long size, char* msg);

void sort(idxType* table, idxType* aux, idxType size);
void shuffleArray(idxType size, idxType* toBeShuffled, idxType cnt);

/* heaps */
void heapDelete(idxType *heapIds, ecType* key, idxType *sz, idxType id, idxType *inheap);
void heapUpdateKey(idxType *heapIds, idxType *inheap, ecType *key, idxType sz, idxType id, ecType newKey);

void randHeapRemove(idxType *heapIds, ecType* key, idxType *sz, idxType i,idxType *inheap);
void heapInsert(idxType *heapIds, ecType* key, idxType *sz, idxType id, idxType *inheap);
void randHeapInsert(idxType *heapIds, ecType* key, idxType *sz, idxType i, idxType *inheap);
void heapify(idxType *heapIds, ecType* key, idxType sz, idxType i,  idxType *inheap);
idxType heapExtractMax(idxType *heapIds, ecType* key, idxType *sz, idxType *inheap);
idxType randHeapExtractMax(idxType *heapIds, ecType* key, idxType *sz, idxType *inheap);
void heapBuild(idxType *heapIds, ecType* key, idxType sz, idxType *inheap);
void heapVerify(idxType *heapIds, ecType* key, idxType sz, idxType *inheap);

void randHeapBuild(idxType *heapIds, ecType* key, idxType sz, idxType *inheap);
void shuffleTab(idxType deb, idxType end, idxType* shuffle);
void maxHeapInsert(dgraph *G, idxType *heapIds, idxType *sz, idxType i);
void maxHeapify(dgraph *G, idxType *heapIds, idxType sz, idxType i);
idxType maxHeapExtract(dgraph *G, idxType *heapIds, idxType *sz);
void maxBuildHeap(dgraph *G, idxType *heapIds, idxType sz);

void maxHeapInsertKeyvals(dgraph *G, idxType *heapIds, idxType *sz, idxType i, ecType *keyvals, vwType *vw);
void maxHeapifyKeyvals(dgraph *G, idxType *heapIds, idxType sz, idxType i, ecType *keyvals, vwType *vw);
idxType maxHeapExtractKeyvals(dgraph *G, idxType *heapIds, idxType *sz, ecType *keyvals, vwType *vw);
void maxBuildHeapKeyvals(dgraph *G, idxType *heapIds, idxType sz, ecType *keyvals, vwType *vw);



#endif
